%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Bar_list = Get_Bars_From_Nodes(Node_list, Excluded_elements)

% Существование узлов из списка Node_list должно проверяться вне данной функции до ее вызова
% Существование элементов из списка Excluded_elements должно проверяться вне данной функции до ее вызова

global DB_ELEMENTS;
global AT_ELEMENTS;

if (isempty(Node_list))
    Bar_list = [];
    return;
end

if (isempty(DB_ELEMENTS))
    Bar_list = [];
    return;
end

Node_list = unique(Node_list);

Elm_list = Get_Elements_From_Nodes(Node_list, Excluded_elements);

if (isempty(Elm_list))
    Bar_list = [];
    return;
end

N_Bars = 0;

for i=1:size(Elm_list,1)
    if (strcmp(DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.type, 'Bar'))
        N_Bars = N_Bars + 1;
    end
end

if (N_Bars == 0)
    Bar_list = [];
    return;
end

Bar_list = zeros(N_Bars,1);

N_Bars = 0;

for i=1:size(Elm_list,1)
    if (strcmp(DB_ELEMENTS{AT_ELEMENTS(Elm_list(i))}.type, 'Bar'))
        N_Bars = N_Bars + 1;
        Bar_list(N_Bars) = Elm_list(i);
    end
end
